#pragma once

#include "vamp-hostsdk/PluginWrapper.h"

namespace vamp::host 
{
  class PluginBufferingAdapter : public PluginWrapper
  {
    public:
      PluginBufferingAdapter(plugin* p);
      virtual ~PluginBufferingAdapter();
      size_t getPreferredStepSize() const;
      size_t getPreferredBlockSize() const;
      bool initialise(size_t channels, size_t stepSize, size_t blockSize);
      size_t getPluginPreferredStepSize() const;
      size_t getPluginPreferredBlockSize() const;
      void setPluginStepSize(size_t stepSize);
      void setPluginBlockSize(size_t blockSize);
      void getActualStepAndBlockSizes(size_t &stepSize, size_t &blockSize);

      void setParameter(std::string, float);
      void selectProgram(std::string);

      OutputList getOutputDescriptors() const;

      void reset();

      FeatureSet process(const float *const *inputBuffers, real_time timestamp);
      
      FeatureSet getRemainingFeatures();
      
    protected:
      class Impl;
      Impl *m_impl;
  };
}
