#include "vamp-hostsdk/PluginWrapper.h"

namespace vamp::host 
{
  PluginWrapper::PluginWrapper(plugin* p) : plugin(p->getInputSampleRate()), m_plugin(p)
  {
  }

  PluginWrapper::~PluginWrapper()
  {
    delete m_plugin;
  }

  bool PluginWrapper::initialise(size_t channels, size_t stepSize, size_t blockSize)
  {
    return m_plugin->initialise(channels, stepSize, blockSize);
  }

  void PluginWrapper::reset()
  {
    m_plugin->reset();
  }

  plugin::InputDomain PluginWrapper::getInputDomain() const
  {
    return m_plugin->getInputDomain();
  }

  std::string PluginWrapper::get_identifier() const
  {
    return m_plugin->get_identifier();
  }

  std::string PluginWrapper::get_name() const
  {
    return m_plugin->get_name();
  }

  std::string PluginWrapper::get_description() const
  {
    return m_plugin->get_description();
  }

  std::string PluginWrapper::get_maker() const
  {
    return m_plugin->get_maker();
  }

  plugin::parameter_descriptors PluginWrapper::get_parameter_descriptors() const
  {
    return m_plugin->get_parameter_descriptors();
  }

  float PluginWrapper::get_parameter(std::string parameter) const
  {
    return m_plugin->get_parameter(parameter);
  }

  void PluginWrapper::set_parameter(std::string parameter, float value)
  {
    m_plugin->set_parameter(parameter, value);
  }

  plugin::programs PluginWrapper::get_programs() const
  {
    return m_plugin->get_programs();
  }

  std::string PluginWrapper::get_current_program() const
  {
    return m_plugin->get_current_program();
  }

  void PluginWrapper::select_program(std::string program)
  {
    m_plugin->select_program(program);
  }

  size_t PluginWrapper::getPreferredStepSize() const
  {
    return m_plugin->getPreferredStepSize();
  }

  size_t PluginWrapper::getPreferredBlockSize() const
  {
    return m_plugin->getPreferredBlockSize();
  }

  size_t PluginWrapper::getMinChannelCount() const
  {
    return m_plugin->getMinChannelCount();
  }

  size_t PluginWrapper::getMaxChannelCount() const
  {
    return m_plugin->getMaxChannelCount();
  }

  plugin::OutputList PluginWrapper::getOutputDescriptors() const
  {
    return m_plugin->getOutputDescriptors();
  }

  plugin::FeatureSet PluginWrapper::process(const float *const *inputBuffers, real_time timestamp)
  {
    return m_plugin->process(inputBuffers, timestamp);
  }

  plugin::FeatureSet PluginWrapper::getRemainingFeatures()
  {
    return m_plugin->getRemainingFeatures();
  }
}
