#pragma once

#include "vamp.h"
#include "vamp-sdk/Plugin.h"

namespace vamp 
{
  class PluginAdapterBase
  {
    public:
      virtual ~PluginAdapterBase();
      const VampPluginDescriptor *getDescriptor();

    protected:
      PluginAdapterBase();

      virtual plugin* createPlugin(float inputSampleRate) = 0;

      class Impl;
      Impl* m_impl;
  };

  template <typename Plugin>
  class PluginAdapter : public PluginAdapterBase
  {
    public:
      PluginAdapter() : PluginAdapterBase() { }
      virtual ~PluginAdapter() { }

    protected:
      plugin* createPlugin(float inputSampleRate) {
          Plugin* pl = new Plugin(inputSampleRate);
          plugin* p = dynamic_cast<plugin*>(pl);
          if (!p) {
              std::cerr << "ERROR: PluginAdapter::createPlugin: "
                        << "Template type is not a plugin!"
                        << std::endl;
              delete pl;
              return 0;
          }
          return p;
      }
  };
}
