#pragma once

#include <string>
#include <vector>

namespace vamp 
{
  class base_plugin 
  {
    public:
      base_plugin() = default;
      virtual ~base_plugin();

    public:
      struct parameter_descriptor
      {
        std::string identifier;
        std::string name;
        std::string description;
        std::string unit;
        float min_value { 0.f };
        float max_value { 0.f };
        float default_value { 0.f };
        bool is_quantized { false };
        float quantize_step { 0.f };
        std::vector<std::string> value_names;
      };

      using parameter_descriptors = std::vector<parameter_descriptor>;
      using programs = std::vector<std::string>;

    public:
      virtual std::string get_identifier() const = 0;
      virtual std::string get_name() const = 0;
      virtual std::string get_description() const = 0;
      virtual std::string get_maker() const = 0;
      virtual float get_parameter(std::string) const { return 0.f; }
      virtual std::string get_current_program() const { return ""; }
      virtual std::string get_type() const = 0;
      virtual parameter_descriptors get_parameter_descriptors() const { return parameter_descriptors(); }
      virtual programs get_programs() const { return programs(); }

      virtual void set_parameter(std::string, float) { } 
      virtual void select_program(std::string) { }
  };
}
